diff -Nrc2 fontutils-0.5/bzrto/input-ccc.c fontutils-0.6/bzrto/input-ccc.c
*** fontutils-0.5/bzrto/input-ccc.c	Mon Aug 17 16:36:03 1992
--- fontutils-0.6/bzrto/input-ccc.c	Sun Oct 11 15:42:33 1992
***************
*** 32,36 ****
  
  /* The information we've collected about the characters.  */
! char_type **chars;
  
  /* The information for resolving various CCC units of measure.  */
--- 32,36 ----
  
  /* The information we've collected about the characters.  */
! bzr_char_type **chars;
  
  /* The information for resolving various CCC units of measure.  */
***************
*** 41,48 ****
  
  /* Go through all of CHARS, setting the various components in the return
!    struct.  Some defaults are taken from TFM_INFO.  */
  
  static ccc_fontinfo_type
! get_ccc_fontinfo (char_type **chars, tfm_global_info_type tfm_info)
  {
    ccc_fontinfo_type ccc_info; /* What we'll return.  */
--- 41,50 ----
  
  /* Go through all of CHARS, setting the various components in the return
!    struct.  Some defaults are taken from TFM_INFO (if it's non-null),
!    and the global `encoding_info'.  */
  
  static ccc_fontinfo_type
! get_ccc_fontinfo (real design_size, bzr_char_type *chars[],
!                   tfm_global_info_type *tfm_info)
  {
    ccc_fontinfo_type ccc_info; /* What we'll return.  */
***************
*** 53,67 ****
  
    /* The designsize is always present.  */
!   ccc_info.design_size = TFM_DESIGN_SIZE (tfm_info);
    
    /* If the `quad' parameter is not present in TFM_INFO to define the
       font's em space, use the design size.  */
!   ccc_info.em = TFM_SAFE_FONTDIMEN (tfm_info, TFM_QUAD_PARAMETER,
!                                     TFM_DESIGN_SIZE (tfm_info));
  
    /* If the `xheight' parameter is present in TFM_INFO, use it.  */
!   if (TFM_XHEIGHT_PARAMETER <= TFM_FONTDIMEN_COUNT (tfm_info))
      {
!       ccc_info.xheight = TFM_FONTDIMEN (tfm_info, TFM_XHEIGHT_PARAMETER);
        xheight_found = true;
      }
--- 55,71 ----
  
    /* The designsize is always present.  */
!   ccc_info.design_size = design_size;
    
    /* If the `quad' parameter is not present in TFM_INFO to define the
       font's em space, use the design size.  */
!   ccc_info.em
!     = tfm_info
!       ? TFM_SAFE_FONTDIMEN (*tfm_info, TFM_QUAD_PARAMETER, design_size)
!       : design_size;
  
    /* If the `xheight' parameter is present in TFM_INFO, use it.  */
!   if (tfm_info && TFM_XHEIGHT_PARAMETER <= TFM_FONTDIMEN_COUNT (*tfm_info))
      {
!       ccc_info.xheight = TFM_FONTDIMEN (*tfm_info, TFM_XHEIGHT_PARAMETER);
        xheight_found = true;
      }
***************
*** 73,123 ****
    for (this_char = 0; this_char < MAX_CHARCODE; this_char++)
      {
!       tfm_char_type *tfm_char;
!       
!       if (chars[this_char] == NULL)
!         continue;
!         
!       tfm_char = CHAR_TFM_INFO (*(chars[this_char]));
! 
!       if (tfm_char && TFM_CHAR_EXISTS (*tfm_char))
          {
!            int char_height = TFM_HEIGHT (*tfm_char);
!            int char_depth = TFM_DEPTH (*tfm_char);
!            string char_name = ENCODING_CHAR_NAME (encoding_info, this_char);
! 
!            if (!cap_height_found && char_height > font_height) 
!              font_height = char_height;
! 
!            if (char_depth > ccc_fontinfo.font_depth) 
!              ccc_info.font_depth = char_depth;
! 
!            /* If it's a letter from which we can find the font's
!               cap_height, use it.  Don't use `F' et al. because they
!               might have serifs that go above the height of the stem.  */
!            if (!cap_height_found && char_name[1] == 0
!                && (*char_name == 'B'
!                    || *char_name == 'D'
!                    || *char_name == 'H'
!                    || *char_name == 'P'
!                    || *char_name == 'R'
!                    || *char_name == 'X'))
!              {
!                ccc_info.cap_height = char_height;
!                cap_height_found = true;
!              }
! 
!            /* If we haven't found the x-height yet, and `this_char' is a
!               letter from which we can determined it, use it.  */
!            if (!xheight_found && char_name[1] == 0
!                && (*char_name == 'u'
!                    || *char_name == 'v'
!                    || *char_name == 'w'
!                    || *char_name == 'x'
!                    || *char_name == 'y'
!                    || *char_name == 'z'))
!              {
!                ccc_info.xheight = char_height;
!                xheight_found = true;
!              }
          }
      }
--- 77,121 ----
    for (this_char = 0; this_char < MAX_CHARCODE; this_char++)
      {
!       if (chars[this_char])
          {
!           bzr_char_type c = *chars[this_char];
!           int char_height = CHAR_HEIGHT (c);
!           int char_depth = CHAR_DEPTH (c);
!           string char_name = ENCODING_CHAR_NAME (encoding_info, this_char);
! 
!           if (char_height > font_height) 
!             font_height = char_height;
! 
!           if (char_depth > ccc_info.font_depth) 
!             ccc_info.font_depth = char_depth;
! 
!           /* If it's a letter from which we can find the font's
!              cap_height, use it.  Don't use `F' et al. because they
!              might have serifs that go above the height of the stem.  */
!           if (!cap_height_found && char_name[1] == 0
!               && (*char_name == 'B'
!                   || *char_name == 'D'
!                   || *char_name == 'H'
!                   || *char_name == 'P'
!                   || *char_name == 'R'
!                   || *char_name == 'X'))
!             {
!               ccc_info.cap_height = char_height;
!               cap_height_found = true;
!             }
! 
!           /* If we haven't found the x-height yet, and `this_char' is a
!              letter from which we can determined it, use it.  */
!           if (!xheight_found && char_name[1] == 0
!               && (*char_name == 'u'
!                   || *char_name == 'v'
!                   || *char_name == 'w'
!                   || *char_name == 'x'
!                   || *char_name == 'y'
!                   || *char_name == 'z'))
!             {
!               ccc_info.xheight = char_height;
!               xheight_found = true;
!             }
          }
      }
***************
*** 128,131 ****
--- 126,133 ----
      ccc_info.cap_height = font_height;
    
+   /* Similarly for the x-height.  */
+   if (!xheight_found)
+     ccc_info.xheight = .6 * font_height;
+ 
    return ccc_info;
  }
***************
*** 138,143 ****
  
  ccc_type **
! parse_ccc_file (string in_filename, char_type **chars_arg,
! 		tfm_global_info_type tfm_info, boolean warning_p)
  {
    string ccc_name = extend_filename (in_filename, "ccc");
--- 140,146 ----
  
  ccc_type **
! parse_ccc_file (string in_filename, bzr_char_type *chars_arg[],
! 		tfm_global_info_type *tfm_info, real design_size,
!                 boolean warning_p)
  {
    string ccc_name = extend_filename (in_filename, "ccc");
***************
*** 154,164 ****
        extern int yyparse ();
        
!       ccc_fontinfo = get_ccc_fontinfo (chars_arg, tfm_info);
! 
!       /* We have to use these globals to communicate with the parser.  */
!       chars = chars_arg;
        ccc_filename = ccc_name;
        
!       /* Parse the input.  */
        yyparse ();
  
--- 157,167 ----
        extern int yyparse ();
        
!       /* We have to use these globals, since we can't alter `yyparse's
!          signature.  */
!       ccc_fontinfo = get_ccc_fontinfo (design_size, chars_arg, tfm_info);
        ccc_filename = ccc_name;
+       chars = chars_arg;
        
!       /* Parse the CCC source file.  */
        yyparse ();
  
diff -Nrc2 fontutils-0.5/bzrto/input-ccc.h fontutils-0.6/bzrto/input-ccc.h
*** fontutils-0.5/bzrto/input-ccc.h	Mon Aug 31 09:35:21 1992
--- fontutils-0.6/bzrto/input-ccc.h	Sun Oct 18 16:32:38 1992
***************
*** 21,25 ****
  #define INPUT_CCC_H
  
- #include "char.h"
  #include "list.h"
  #include "tfm.h"
--- 21,24 ----
***************
*** 94,98 ****
  extern FILE *ccc_file;
  extern string ccc_filename;
! extern char_type **chars;
  extern ccc_fontinfo_type ccc_fontinfo;
  extern ccc_type *ccc_chars[];
--- 93,97 ----
  extern FILE *ccc_file;
  extern string ccc_filename;
! extern bzr_char_type **chars;
  extern ccc_fontinfo_type ccc_fontinfo;
  extern ccc_type *ccc_chars[];
***************
*** 100,108 ****
  
  /* Read the CCC file NAME, extended with `.ccc' if necessary.  Warn
!    about the file not existing only if WARN_P is true.  Update `chars',
     taking defaults from T.  */
  
! extern ccc_type **parse_ccc_file (string name, char_type **chars,
!                                   tfm_global_info_type t, boolean warn_p);
  
  #endif /* not CCC_H */
--- 99,108 ----
  
  /* Read the CCC file NAME, extended with `.ccc' if necessary.  Warn
!    about the file not existing only if WARN_P is true.  Update CHARS,
     taking defaults from T.  */
  
! extern ccc_type **parse_ccc_file
!   (string name, bzr_char_type **chars, tfm_global_info_type *t,
!    real design_size, boolean warn_p);
  
  #endif /* not CCC_H */
